# Nástroj pro automatickou registraci do Gitei

Určeno pro registraci organizátorů seminářů na MFF UK.

## Build

Build má následující závislosti:
* [Pipenv](https://pipenv.readthedocs.io/en/latest/)

Po každém `git pull` je potřeba zavolat `pipenv sync`. Tím se sesynchronizují závislosti a všude se pak používají
 správné verze.

## Spouštění

Vyžaduje Python 3.5 a novější.

```sh
pipenv run python register.py --help
```

## Použití

Snaha je, aby se co nejvíce dokumentace nacházelo v kódu. Vysvětlení proto získáte zavoláním programu s argumentem
`--help`. Žádné další informace by k tomu neměly být potřeba.

## Konfigurace

Pro perzistentní konfiguraci je možné použít soubor `config.py` zkopírováním z `config_default.py`.

## Dokumentace API Gitei

Gitea má specifikaci API popsanou dle specifikace OpenAPI 2.0 (dříve nazýváno Swagger). Pokud není explicitně řečeno
jinak, je tato specifikace vystavena na každé běžící instanci a to na cestě `/api/swagger`. Přesněji, na této cestě je
standardní vygenerovaný webový interface ke specifikaci. Specifikace samotná se nachází (alespoň v době psaní) na cestě
`/swagger.v1.json`.

K tomuto API je vygenerován klient aktuálně se nacházející
 [zde](https://gitea.ks.matfyz.cz/vasek/gitea-swagger-client). Kód je v podstatě čistě vygenerovaný nástrojem
 `swagger-codegen` (link v repozitáři s klientem). Obsahuje akorát dva drobné patche, protože bez nich vůbec nejde
 naimportovat.
 
 `Pipenv` si z tohoto repozitáře stáhne kód a používá ho jako knihovnu.